#ifndef __ARWPCI_H__
#define __ARWPCI_H__
 
//****************************************************************************
// Copyright (C) 2000,2001  ARW Elektronik Germany
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// This product is not authorized for use as critical component in 
// life support systems without the express written approval of 
// ARW Elektronik Germany.
//  
// Please announce changes and hints to ARW Elektronik
//
// Maintainer(s): Klaus Hitschler (klaus.hitschler@gmx.de)
//
//****************************************************************************

//****************************************************************************
//
// askpci.h - definitions for basic access functions of pci information
//
// $Log: askpci.h,v $
// Revision 1.2  2001/11/20 20:12:50  klaus
// included new header and CVS log
//
//
// derived from code originated from Dirk Muehlenberg         AR   18.02.2000
//
//****************************************************************************

/*--- INCLUDES -------------------------------------------------------------------------*/
#include <linux/version.h>
#include <linux/pci.h>
#include <asm/types.h>

#ifndef NULL
  #define NULL 0
#endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,3,0)  
#define kfree_s(ptr, size)  kfree(ptr)   /* a workaround cause kfree_s is disapeared in V 2.4 */
#endif

/*--- TYPEDEFS -------------------------------------------------------------------------*/
typedef struct
{
  __u32 base_address;
  __u32 size;
  __u16 type;
  __u16 prefetchable;
} IO_DESC;

typedef struct _PCIConfigHeader
{
  __u16 device_id;
  __u16 vendor_id;
  __u16 status, command;
  __u16 class_code;
  __u8  rev_id;
  __u32 unknown1; 
  IO_DESC desc[6]; 
  __u32 CBSIS;
  __u16 subsystem_id;
  __u16 subsystem_vendor_id; 
 
 /* end of PCI Configuration register used here */
 
  char  busnr;
  char  devnr;
  char  irq;
  short index;
} PCIConfigHeader;

/*--- PROTOTYPES -------------------------------------------------------------------------*/
PCIConfigHeader *GetPCIConfigHeader(__u16, __u16, short);

#endif  /* __ARWPCI_H__ */

